/*$Id: ezmlm-list.c,v 1.13 1999/01/14 04:01:57 lindberg Exp $*/
/*$Name: ezmlm-idx-0324 $*/
#include "strerr.h"
#include "readwrite.h"
#include "substdio.h"
#include "subscribe.h"
#include "exit.h"
#include "sgetopt.h"
#include "errtxt.h"
#include "idx.h"

#define FATAL "ezmlm-list: fatal: "

static int flagusewhere = 1;	/* default: -A; show only sublist addresses */

void *psql = (void *) 0;

void die_write()
{
  strerr_die3sys(111,FATAL,ERR_WRITE,"stdout: ");
}

void die_usage()
{
  strerr_die1x(100,"ezmlm-list: usage: ezmlm-list [-aAmMvV] [-n msg] dir");
}

static char outbuf[512];
static substdio ssout = SUBSTDIO_FDBUF(write,1,outbuf,sizeof(outbuf));

int subwrite(s,l)
char *s;
unsigned int l;
{
  return substdio_put(&ssout,s,l) | substdio_put(&ssout,"\n",1);
}

void main(argc,argv)
int argc;
char **argv;
{
  char *dir;
  int flagmysql = 1;	/* use if supported */
  unsigned long msgnum = 0;
  int opt;

  while ((opt = getopt(argc,argv,"aAmMn:vV")) != opteof)
    switch(opt) {
      case 'a': flagusewhere = 0; break;
      case 'A': flagusewhere = 1; break;
      case 'm': flagmysql = 1; break;
      case 'M': flagmysql = 0; break;
      case 'n': if (optarg) scan_ulong(optarg,&msgnum); break;
      case 'v':
      case 'V': strerr_die2x(0,
	"ezmlm-list version: ezmlml-0.53+",EZIDX_VERSION);
      default:
	die_usage();
    }

  dir = argv[optind++];
  if (!dir) die_usage();
  if (dir[0] != '/')
    strerr_die2x(100,FATAL,ERR_SLASH);

  (void) putsubs(dir,"",flagmysql,flagusewhere,msgnum,subwrite,FATAL);
  if (substdio_flush(&ssout) == -1) die_write(FATAL);
  closesql();
  _exit(0);
}
