/*$Id: checktag.c,v 1.8 1999/01/14 05:19:53 lindberg Exp $*/
/*$Name: ezmlm-idx-0324 $*/
#include "stralloc.h"
#include "scan.h"
#include "fmt.h"
#include "cookie.h"
#include "strerr.h"
#include "errtxt.h"
#include "subscribe.h"
#include <mysql/mysql.h>


static stralloc line = {0};
static stralloc quoted = {0};
static strnum[FMT_ULONG];

char *checktag (dir,num,hash)
/* reads dir/sql. If not present, returns success (NULL). If dir/sql is    */
/* present, checks hash against the cookie table. If match, returns success*/
/* (NULL), else returns "". If error, returns error string. */

char *dir;				/* the db base dir */
unsigned long num;			/* message number */
stralloc *hash;				/* cookie */
{
  MYSQL_RES *result;
  char *table = "ezmlm";		/* base name for tables */
  char *sublistname = (char *) 0;	/* name of the list */
  char *r;

  if ((r = opensql(dir,&table,&sublistname))) {
    if (!*r) return 0;			/* not found => success! */
       else return r;
  }

  strnum[fmt_ulong(strnum,num)] = '\0';
/* SELECT msgnum FROM table_cookie WHERE msgnum=num and cookie='hash' */
/* succeeds only is everything correct. 'hash' is qouted since it is  */
/*  potentially hostile. */

  if (!stralloc_copys(&line,"SELECT msgnum FROM ")) return ERR_NOMEM;
  if (!stralloc_cats(&line,table)) return ERR_NOMEM;
  if (!stralloc_cats(&line,"_cookie WHERE msgnum=")) return ERR_NOMEM;
  if (!stralloc_cats(&line,strnum)) return ERR_NOMEM;
  if (!stralloc_cats(&line," and cookie='")) return ERR_NOMEM;
  if (!stralloc_ready(&quoted,2 * hash->len + 1)) return ERR_NOMEM;
  quoted.len = mysql_escape_string(quoted.s,hash->s,hash->len);
  if (!stralloc_cat(&line,&quoted)) return ERR_NOMEM;
  if (!stralloc_cats(&line,"'")) return ERR_NOMEM;

  if (mysql_real_query((MYSQL *) psql,line.s,line.len))	/* select */
	return mysql_error((MYSQL *) psql);
  if (!(result = mysql_use_result((MYSQL *) psql)))
	return mysql_error((MYSQL *) psql);
  if (!mysql_fetch_row(result)) {
    if (!mysql_eof(result))		/* some error occurred */
	return mysql_error((MYSQL *) psql);
      mysql_free_result(result);	/* eof => query ok, but null result*/
      return "";
  }
  mysql_free_result(result);		/* success! cookie matches */
  return (char *) 0;
}
