/*$Id: subscribe.h,v 1.11 1999/02/21 20:29:37 lindberg Exp $*/
/*$Name: ezmlm-idx-0324 $*/
#ifndef SUBSCRIBE_H
#define SUBSCRIBE_H

#include "stralloc.h"
/*#define WITH_PROTO*/


/* these are the subroutines used for interfacing with the subscriber and  */
/* moderator address databases. For the put/to address output routines     */
/* the 'username' if defined is omitted from the output. flagadd = 1 adds  */
/* a subscriber, flagadd = 0 removes the address. To use e.g. a SQL data-  */
/* base for addresses, just replace these routines and rebuild ezmlm.      */

#ifdef WITH_PROTO

extern int subscribe(char *dir,char *username,int flagadd,char *from,
	char *event, int flagmysql, unsigned int forcehash, char *FATAL);

extern char *issub(char *dir,char *username, char *FATAL);

extern unsigned int putsubs(char *dir,char *username,int flagmysql,
	int flagusewhere, unsigned long msgnum,
	int (*subwrite)(char *s, unsigned int n), char *fatal);

/*		int subwrite(char *string, unsigned int length); */

extern void tagmsg(char *dir, unsigned long msgnum, char *sender, char *action,
	int flagsublist, stralloc *hashout, char *fatal);

extern char *logmsg(char *dir, unsigned long msgnum, int done);

extern char *checktag(char *dir, unsigned long msgnum,
	stralloc *hash);

extern int subreceipt(char *dir, unsigned long msgnum,stralloc *cookie,
	char *listaddr,int done, char *info, char *fatal);

extern char *getlistno(char *dir, unsigned long msgnum,char *listname);

extern void searchlog(char *dir, char *search, int subwrite(), char *fatal);

extern char *opensql(char *dir, char **table, char **where);

extern void closesql();

#else

extern int subscribe();
extern char *issub();
extern unsigned int putsubs();
extern void tagmsg();
extern char *logmsg();
extern char *checktag();
extern int subreceipt();
extern char *getlistno();
extern char *opensql();
extern void closesql();
extern void searchlog();

#endif
extern void *psql;		/* contains SQL handle */
extern stralloc listno;		/* list number */
#endif
